]> asedeno.scripts.mit.edu Git - linux.git/blob - scripts/link-vmlinux.sh
moduleparam: Save information about built-in modules in separate file
[linux.git] / scripts / link-vmlinux.sh
1 #!/bin/sh
2 # SPDX-License-Identifier: GPL-2.0
3 #
4 # link vmlinux
5 #
6 # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7 # $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8 # in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9 # $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10 # (not within --whole-archive), and do not require symbol indexes added.
11 #
12 # vmlinux
13 #   ^
14 #   |
15 #   +--< $(KBUILD_VMLINUX_OBJS)
16 #   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
17 #   |
18 #   +--< $(KBUILD_VMLINUX_LIBS)
19 #   |    +--< lib/lib.a + more
20 #   |
21 #   +-< ${kallsymso} (see description in KALLSYMS section)
22 #
23 # vmlinux version (uname -v) cannot be updated during normal
24 # descending-into-subdirs phase since we do not yet know if we need to
25 # update vmlinux.
26 # Therefore this step is delayed until just before final link of vmlinux.
27 #
28 # System.map is generated to document addresses of all kernel symbols
29
30 # Error out on error
31 set -e
32
33 # Nice output in kbuild format
34 # Will be supressed by "make -s"
35 info()
36 {
37         if [ "${quiet}" != "silent_" ]; then
38                 printf "  %-7s %s\n" ${1} ${2}
39         fi
40 }
41
42 # Link of vmlinux.o used for section mismatch analysis
43 # ${1} output file
44 modpost_link()
45 {
46         local objects
47
48         objects="--whole-archive                                \
49                 ${KBUILD_VMLINUX_OBJS}                          \
50                 --no-whole-archive                              \
51                 --start-group                                   \
52                 ${KBUILD_VMLINUX_LIBS}                          \
53                 --end-group"
54
55         ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
56 }
57
58 # Link of vmlinux
59 # ${1} - optional extra .o files
60 # ${2} - output file
61 vmlinux_link()
62 {
63         local lds="${objtree}/${KBUILD_LDS}"
64         local objects
65
66         if [ "${SRCARCH}" != "um" ]; then
67                 objects="--whole-archive                        \
68                         ${KBUILD_VMLINUX_OBJS}                  \
69                         --no-whole-archive                      \
70                         --start-group                           \
71                         ${KBUILD_VMLINUX_LIBS}                  \
72                         --end-group                             \
73                         ${1}"
74
75                 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} -o ${2}      \
76                         -T ${lds} ${objects}
77         else
78                 objects="-Wl,--whole-archive                    \
79                         ${KBUILD_VMLINUX_OBJS}                  \
80                         -Wl,--no-whole-archive                  \
81                         -Wl,--start-group                       \
82                         ${KBUILD_VMLINUX_LIBS}                  \
83                         -Wl,--end-group                         \
84                         ${1}"
85
86                 ${CC} ${CFLAGS_vmlinux} -o ${2}                 \
87                         -Wl,-T,${lds}                           \
88                         ${objects}                              \
89                         -lutil -lrt -lpthread
90                 rm -f linux
91         fi
92 }
93
94
95 # Create ${2} .o file with all symbols from the ${1} object file
96 kallsyms()
97 {
98         info KSYM ${2}
99         local kallsymopt;
100
101         if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
102                 kallsymopt="${kallsymopt} --all-symbols"
103         fi
104
105         if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
106                 kallsymopt="${kallsymopt} --absolute-percpu"
107         fi
108
109         if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
110                 kallsymopt="${kallsymopt} --base-relative"
111         fi
112
113         local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL}               \
114                       ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
115
116         local afile="`basename ${2} .o`.S"
117
118         ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
119         ${CC} ${aflags} -c -o ${2} ${afile}
120 }
121
122 # Create map file with all symbols from ${1}
123 # See mksymap for additional details
124 mksysmap()
125 {
126         ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
127 }
128
129 sortextable()
130 {
131         ${objtree}/scripts/sortextable ${1}
132 }
133
134 # Delete output files in case of error
135 cleanup()
136 {
137         rm -f .tmp_System.map
138         rm -f .tmp_kallsyms*
139         rm -f .tmp_vmlinux*
140         rm -f System.map
141         rm -f vmlinux
142         rm -f vmlinux.o
143 }
144
145 on_exit()
146 {
147         if [ $? -ne 0 ]; then
148                 cleanup
149         fi
150 }
151 trap on_exit EXIT
152
153 on_signals()
154 {
155         exit 1
156 }
157 trap on_signals HUP INT QUIT TERM
158
159 #
160 #
161 # Use "make V=1" to debug this script
162 case "${KBUILD_VERBOSE}" in
163 *1*)
164         set -x
165         ;;
166 esac
167
168 if [ "$1" = "clean" ]; then
169         cleanup
170         exit 0
171 fi
172
173 # We need access to CONFIG_ symbols
174 . include/config/auto.conf
175
176 # Update version
177 info GEN .version
178 if [ -r .version ]; then
179         VERSION=$(expr 0$(cat .version) + 1)
180         echo $VERSION > .version
181 else
182         rm -f .version
183         echo 1 > .version
184 fi;
185
186 # final build of init/
187 ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
188
189 #link vmlinux.o
190 info LD vmlinux.o
191 modpost_link vmlinux.o
192
193 # modpost vmlinux.o to check for section mismatches
194 ${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
195
196 info MODINFO modules.builtin.modinfo
197 ${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
198
199 kallsymso=""
200 kallsyms_vmlinux=""
201 if [ -n "${CONFIG_KALLSYMS}" ]; then
202
203         # kallsyms support
204         # Generate section listing all symbols and add it into vmlinux
205         # It's a three step process:
206         # 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
207         #     but __kallsyms is empty.
208         #     Running kallsyms on that gives us .tmp_kallsyms1.o with
209         #     the right size
210         # 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
211         #     the right size, but due to the added section, some
212         #     addresses have shifted.
213         #     From here, we generate a correct .tmp_kallsyms2.o
214         # 3)  That link may have expanded the kernel image enough that
215         #     more linker branch stubs / trampolines had to be added, which
216         #     introduces new names, which further expands kallsyms. Do another
217         #     pass if that is the case. In theory it's possible this results
218         #     in even more stubs, but unlikely.
219         #     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
220         #     other bugs.
221         # 4)  The correct ${kallsymso} is linked into the final vmlinux.
222         #
223         # a)  Verify that the System.map from vmlinux matches the map from
224         #     ${kallsymso}.
225
226         kallsymso=.tmp_kallsyms2.o
227         kallsyms_vmlinux=.tmp_vmlinux2
228
229         # step 1
230         vmlinux_link "" .tmp_vmlinux1
231         kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
232
233         # step 2
234         vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
235         kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
236
237         # step 3
238         size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms1.o)
239         size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms2.o)
240
241         if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
242                 kallsymso=.tmp_kallsyms3.o
243                 kallsyms_vmlinux=.tmp_vmlinux3
244
245                 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
246
247                 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
248         fi
249 fi
250
251 info LD vmlinux
252 vmlinux_link "${kallsymso}" vmlinux
253
254 if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
255         info SORTEX vmlinux
256         sortextable vmlinux
257 fi
258
259 info SYSMAP System.map
260 mksysmap vmlinux System.map
261
262 # step a (see comment above)
263 if [ -n "${CONFIG_KALLSYMS}" ]; then
264         mksysmap ${kallsyms_vmlinux} .tmp_System.map
265
266         if ! cmp -s System.map .tmp_System.map; then
267                 echo >&2 Inconsistent kallsyms data
268                 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
269                 exit 1
270         fi
271 fi